package net.asukaze.cassava.core.command;

import net.asukaze.cassava.core.model.ICassavaTableModel;

public class CellChangeCommand implements Command {
	private ICassavaTableModel model;
	private String value;
	private int rowIndex;
	private int colIndex;

	public CellChangeCommand(ICassavaTableModel model, String value,
			int rowIndex, int colIndex) {
		this.model = model;
		this.value = value;
		this.rowIndex = rowIndex;
		this.colIndex = colIndex;
	}

	public boolean canUndo() {
		return (value != null);
	}

	public Status run() {
		String oldValue = model.getValueAt(rowIndex, colIndex);
		if(value.equals(oldValue)){
			return NO_CHANGE;
		}else{
			model.setValueAt(value, rowIndex, colIndex);
			value = oldValue;
			return CHANGED;
		}
	}
	public Status undo() {
		return run();
	}
}
