package net.asukaze.cassava.core.command;

import net.asukaze.cassava.core.model.ICassavaTableModel;

public class ClearCommand implements Command {
	private ICassavaTableModel model;
	private int rows;
	private int columns;

	public ClearCommand(ICassavaTableModel model) {
		this(model, 0, 0);
	}

	public ClearCommand(ICassavaTableModel model, int rows, int columns) {
		this.model = model;
		this.rows = rows;
		this.columns = columns;
	}

	public boolean canUndo() {
		return false;
	}

	public Status run() throws CommandException {
		boolean changed = (model.getRowCount() > 0);
		model.clear();
		if (rows > 0 && columns > 0) {
			model.setValueAt("", rows - 1, columns - 1);
		}
		if (changed) {
			return Status.CHANGED;
		} else {
			return Status.NO_CHANGE;
		}
	}

	public Status undo() throws CommandException {
		return Status.FAIL;
	}
}
