package net.asukaze.cassava.io.util;

import java.awt.FileDialog;
import java.awt.Frame;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

/**
 * Java Web Start ͒ʏ File IO Ńt@CJ܂B
 */
public class HybridFileDialog {
	/**
	 * t@C_CAO\AIꂽt@CJ܂B
	 * 
	 * @param parent
	 *            _CAO̐et[
	 * @param title
	 *            _CAÕ^Cg
	 * @return java.io.ReaderB[ULZꍇnullBǂݎecloseĂB
	 * @throws IOException
	 *             t@CJۂɃG[ꍇ
	 */
	public static FileInfo openFile(Frame parent, String title)
			throws IOException {
		InputStream inputStream = null;
		String filename = null;
		boolean nojnlp = false;
		try {
			Class<?> serviceManager = Class
					.forName("javax.jnlp.ServiceManager"); //$NON-NLS-1$
			Method lookup = serviceManager.getMethod("lookup", String.class); //$NON-NLS-1$
			Object fileOpenService = lookup.invoke(null,
					"javax.jnlp.FileOpenService"); //$NON-NLS-1$
			Method openFileDialog = fileOpenService.getClass().getMethod(
					"openFileDialog", String.class, String[].class); //$NON-NLS-1$
			Object fileContents = openFileDialog.invoke(fileOpenService, null,
					null);
			if (fileContents == null) {
				return null;
			}
			Method getName = fileContents.getClass().getMethod("getName"); //$NON-NLS-1$
			filename = getName.invoke(fileContents).toString();
			Method getInputStream = fileContents.getClass().getMethod(
					"getInputStream"); //$NON-NLS-1$
			inputStream = (InputStream) (getInputStream.invoke(fileContents));
		} catch (ClassNotFoundException exc) {
			nojnlp = true;
		} catch (NoSuchMethodException e) {
			nojnlp = true;
		} catch (IllegalAccessException e) {
			nojnlp = true;
		} catch (InvocationTargetException e) {
			// getInputStream() ŔOBbvOēȂB
			Throwable cause = e.getCause();
			if (cause instanceof IOException) {
				throw (IOException) cause;
			} else if (cause instanceof RuntimeException) {
				throw (RuntimeException) cause;
			} else {
				throw new RuntimeException(e);
			}
		}
		if (nojnlp) {
			FileDialog openFileDialog = new FileDialog(parent, title,
					FileDialog.LOAD);
			openFileDialog.setVisible(true);
			if (openFileDialog.getFile() == null) {
				return null;
			}
			filename = openFileDialog.getDirectory() + openFileDialog.getFile();
			inputStream = new FileInputStream(filename);
		}
		return new FileInfo(inputStream, filename);
	}

	public static String saveFile(Frame parent, String title,
			InputStream stream, String name) throws IOException {
		String filename = null;
		boolean nojnlp = false;
		try {
			Class<?> serviceManager = Class
					.forName("javax.jnlp.ServiceManager"); //$NON-NLS-1$
			Method lookup = serviceManager.getMethod("lookup", String.class); //$NON-NLS-1$
			Object fileSaveService = lookup.invoke(null,
					"javax.jnlp.FileSaveService"); //$NON-NLS-1$
			Method saveFileDialog = fileSaveService.getClass().getMethod(
					"saveFileDialog", String.class, String[].class, //$NON-NLS-1$
					InputStream.class, String.class);
			Object fileContents = saveFileDialog.invoke(fileSaveService, null,
					null, stream, name);
			if (fileContents == null) {
				return null;
			}
			Method getName = fileContents.getClass().getMethod("getName"); //$NON-NLS-1$
			filename = getName.invoke(fileContents).toString();
		} catch (ClassNotFoundException exc) {
			nojnlp = true;
		} catch (NoSuchMethodException e) {
			nojnlp = true;
		} catch (IllegalAccessException e) {
			nojnlp = true;
		} catch (InvocationTargetException e) {
			// getInputStream() ŔOBbvOēȂB
			Throwable cause = e.getCause();
			if (cause instanceof IOException) {
				throw (IOException) cause;
			} else if (cause instanceof RuntimeException) {
				throw (RuntimeException) cause;
			} else {
				throw new RuntimeException(e);
			}
		}
		if (nojnlp) {
			FileDialog saveFileDialog = new FileDialog(parent, title,
					FileDialog.SAVE);
			saveFileDialog.setFile(name);
			saveFileDialog.setVisible(true);
			if (saveFileDialog.getFile() == null) {
				return null;
			}
			filename = saveFileDialog.getDirectory() + saveFileDialog.getFile();
			FileOutputStream fos = new FileOutputStream(filename);
			while (true) {
				int b = stream.read();
				if (b < 0) {
					break;
				}
				fos.write(b);
			}
			fos.close();
		}
		return filename;
	}
}
