package net.asukaze.cassava.encoding.command;

import net.asukaze.cassava.core.model.ICassavaTableModel;
import net.asukaze.cassava.core.model.Selection;

public class TransformAZCommand extends TransformCommand {
	public TransformAZCommand(ICassavaTableModel model, Selection selection) {
		super(model, selection);
	}

	@Override
	protected String transform(String value) {
		StringBuilder sb = new StringBuilder();
		for (char c : value.toCharArray()) {
			if (c == ' ') {
				c = '@';
			} else if (c == '\'') {
				c = 'f';
			} else if (c == '\"') {
				c = 'h';
			} else if (c == '\\') {
				c = '';
			} else if (c >= '!' && c <= '~') {
				c += ('`' - 'A');
			}
			sb.append(c);
		}
		return sb.toString();
	}
}
