package net.asukaze.cassava.encoding.command;

import net.asukaze.cassava.core.model.ICassavaTableModel;
import net.asukaze.cassava.core.model.Selection;

public class TransformKHCommand extends TransformCommand {
	public TransformKHCommand(ICassavaTableModel model, Selection selection) {
		super(model, selection);
	}

	private static void append(StringBuilder sb, char c) {
		sb.append(c);
	}

	private static void append(StringBuilder sb, String str) {
		sb.append(str);
	}

	private static void append(StringBuilder sb, int c) {
		sb.append((char) c);
	}

	@Override
	protected String transform(String value) {
		StringBuilder sb = new StringBuilder();
		for (char c : value.toCharArray()) {
			if (c == '@') {
				append(sb, ' ');
			} else if (c == '') {
				append(sb, '');
			} else if (c == '') {
				append(sb, '');
			} else if (c == '') {
				append(sb, '');
			} else if (c == '') {
				append(sb, "");
			} else if (c == 'J') {
				append(sb, '');
			} else if (c == 'K') {
				append(sb, '');
			} else if (c == '[') {
				append(sb, '');
			} else if (c == 'B') {
				append(sb, '');
			} else if (c == 'u') {
				append(sb, '');
			} else if (c == 'v') {
				append(sb, '');
			} else if (c == 'A') {
				append(sb, '');
			} else if (c == 'E') {
				append(sb, '');
			} else if (c < '@' || c > '') {
				append(sb, c);
			} else if (c == 'b') {
				append(sb, '');
			} else if (c >= '@' && c <= 'I') {
				int x = (c - '@');
				append(sb, ((x % 2) != 0) ? ('' + (x / 2)) : ('' + (x / 2)));
			} else if (c >= 'J' && c <= 'a') {
				int x = (c - 'J');
				append(sb, '' + (x / 2));
				if ((x % 2) != 0) {
					append(sb, '');
				}
			} else if (c >= 'c' && c <= 'h') {
				int x = (c - 'c');
				append(sb, '' + (x / 2));
				if ((x % 2) != 0) {
					append(sb, '');
				}
			} else if (c >= 'i' && c <= 'm') {
				append(sb, '' + (c - 'i'));
			} else if (c >= 'n' && c <= '|') {
				int x = (c - 'n');
				append(sb, '' + (x / 3));
				if ((x % 3) == 1) {
					append(sb, '');
				} else if ((x % 3) == 2) {
					append(sb, '');
				}
			} else if (c >= '}' && c <= '') {
				append(sb, '' + (c - '}'));
			} else if (c >= '' && c <= '') {
				int x = (c - '');
				append(sb, ((x % 2) != 0) ? ('' + (x / 2)) : ('' + (x / 2)));
			} else if (c >= '' && c <= '') {
				append(sb, '' + (c - ''));
			} else {
				append(sb, c);
			}
		}
		return sb.toString();
	}
}
