package net.asukaze.cassava.ui.action;

import net.asukaze.cassava.core.command.Command;
import net.asukaze.cassava.core.model.ICassavaViewModel;
import net.asukaze.cassava.core.model.Selection;
import net.asukaze.cassava.ui.command.ConnectCellCommand;
import net.asukaze.cassava.ui.command.ConnectMoveCellCommand;
import net.asukaze.cassava.ui.command.ConnectRowCommand;

public class ConnectCellAction extends Action {
	@Override
	public Command run() throws Exception {
		ICassavaViewModel viewModel = getViewModel();
		Selection selection = viewModel.getSelection();
		if (selection.isOneCellSelected()) {
			int row = viewModel.getCurrentRow();
			int col = viewModel.getCurrentCol();
			if (col == 0) {
				if (row == 0) {
					return null;
				} else {
					return new ConnectRowCommand(getTableModel(), row - 1, row);
				}
			} else {
				return new ConnectMoveCellCommand(getTableModel(), row, col - 1);
			}
		} else {
			return new ConnectCellCommand(getTableModel(), selection);
		}
	}
}
