package net.asukaze.cassava.ui.action;

import javax.swing.JTextArea;
import javax.swing.table.TableCellEditor;

import net.asukaze.cassava.core.command.Command;
import net.asukaze.cassava.core.model.ICassavaTableModel;
import net.asukaze.cassava.io.command.CopyCommand;
import net.asukaze.cassava.io.command.CopyCommand.Type;
import net.asukaze.cassava.ui.table.CassavaGrid;
import net.asukaze.cassava.ui.table.CassavaTableCellEditor;

public class CutAction extends Action {
	@Override
	public Command run() throws Exception {
		CassavaGrid grid = getCassavaGrid();
		if (grid.isEditing()) {
			TableCellEditor cellEditor = grid.getCellEditor();
			if (cellEditor instanceof CassavaTableCellEditor) {
				JTextArea textArea = ((CassavaTableCellEditor) cellEditor)
						.getTextArea();
				textArea.cut();
			}
			return null;
		} else {
			ICassavaTableModel model = grid.getTableModel();
			return new CopyCommand(model, grid.getViewModel().getSelection(),
					model.getDataFormat(), Type.CUT);
		}
	}
}
