package net.asukaze.cassava.ui.action;

import net.asukaze.cassava.core.command.Command;
import net.asukaze.cassava.io.command.OpenFileCommand;
import net.asukaze.cassava.io.util.FileInfo;
import net.asukaze.cassava.io.util.HybridFileDialog;
import net.asukaze.cassava.ui.Messages;

public class OpenAction extends Action {
	@Override
	public Command run() throws Exception {
		FileInfo fileinfo = HybridFileDialog.openFile(getFrame(),
				Messages.getString(Messages.OPEN_DIALOG_TITLE));
		if (fileinfo != null && fileinfo.getReader() != null) {
			Command cmd = new OpenFileCommand(getTableModel(), getViewModel(),
					fileinfo.getReader(), fileinfo.getFilename());
			getCassavaGrid().getCommandStack().run(cmd);
			RefreshAction.execute(getCassavaGrid());
		}
		return null;
	}
}
