package net.asukaze.cassava.ui.command;

import net.asukaze.cassava.core.command.Command;
import net.asukaze.cassava.core.command.CommandException;
import net.asukaze.cassava.core.model.ICassavaTableModel;

public class ConnectMoveCellCommand implements Command {
	private ICassavaTableModel model;
	private int rowIndex;
	private int columnIndex;
	private int splitIndex;

	public ConnectMoveCellCommand(ICassavaTableModel model, int rowIndex,
			int columnIndex) {
		this.model = model;
		this.rowIndex = rowIndex;
		this.columnIndex = columnIndex;
	}

	@Override
	public boolean canUndo() {
		return true;
	}

	@Override
	public Status run() throws CommandException {
		String left = model.getValueAt(rowIndex, columnIndex);
		String right = model.getValueAt(rowIndex, columnIndex + 1);
		splitIndex = left.length();
		model.setValueAt(left + right, rowIndex, columnIndex);
		model.deleteCellsLeft(rowIndex, columnIndex + 1, 1, 1);
		return CHANGED;
	}

	@Override
	public Status undo() throws CommandException {
		int columnCount = model.getColumnCount();
		int columnIndex1 = columnIndex + 1;
		model.insertCellsRight(rowIndex, columnIndex1, 1, 1);
		model.setColumnCount(columnCount);
		String value = model.getValueAt(rowIndex, columnIndex);
		model.setValueAt(value.substring(0, splitIndex), rowIndex, columnIndex);
		model.setValueAt(value.substring(splitIndex), rowIndex, columnIndex1);
		return CHANGED;
	}
}
