package net.asukaze.cassava.ui.command;

import net.asukaze.cassava.core.command.Command;
import net.asukaze.cassava.core.command.CommandException;
import net.asukaze.cassava.core.model.ICassavaTableModel;
import net.asukaze.cassava.core.model.Selection;
import net.asukaze.cassava.core.util.ModelUtil;

public class DeleteCellLeftCommand implements Command {
	private ICassavaTableModel model;
	private Selection selection;
	private ICassavaTableModel old;
	private int columnCount;

	public DeleteCellLeftCommand(ICassavaTableModel model, Selection selection) {
		this.model = model;
		this.selection = selection;
	}

	@Override
	public boolean canUndo() {
		return true;
	}

	@Override
	public Status run() throws CommandException {
		old = ModelUtil.copy(model, selection);
		columnCount = model.getColumnCount();
		ModelUtil.deleteCellsLeft(model, selection);
		return CHANGED;
	}

	@Override
	public Status undo() throws CommandException {
		ModelUtil.insertCellsRight(model, selection);
		ModelUtil.paste(model, selection, old);
		model.setColumnCount(columnCount);
		old = null;
		return CHANGED;
	}
}
