package net.asukaze.cassava.ui.command;

import net.asukaze.cassava.core.command.Command;
import net.asukaze.cassava.core.command.CommandException;
import net.asukaze.cassava.core.model.ICassavaTableModel;
import net.asukaze.cassava.core.model.Selection;
import net.asukaze.cassava.core.util.ModelUtil;

public class DeleteCellUpCommand implements Command {
	private ICassavaTableModel model;
	private Selection selection;
	private ICassavaTableModel old;
	private int rowCount;

	public DeleteCellUpCommand(ICassavaTableModel model, Selection selection) {
		this.model = model;
		this.selection = selection;
	}

	@Override
	public boolean canUndo() {
		return true;
	}

	@Override
	public Status run() throws CommandException {
		old = ModelUtil.copy(model, selection);
		rowCount = model.getRowCount();
		ModelUtil.deleteCellsUp(model, selection);
		return CHANGED;
	}

	@Override
	public Status undo() throws CommandException {
		ModelUtil.insertCellsDown(model, selection);
		ModelUtil.paste(model, selection, old);
		model.setRowCount(rowCount);
		old = null;
		return CHANGED;
	}
}
