package net.asukaze.cassava.ui.table;

import java.awt.Component;

import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;

import net.asukaze.cassava.core.model.CellCalculator;

@SuppressWarnings("serial")
public class CassavaTableCellRenderer extends DefaultTableCellRenderer {
	private String sanitize(String str) {
		return str.replace("&", "&amp;").replace("<", "&lt;").replace(">",
				"&gt;").replace("\"", "&quot;");
	}

	public Component getTableCellRendererComponent(JTable table, Object value,
			boolean isSelected, boolean hasFocus, int row, int column) {
		try {
			if (table instanceof CassavaGrid && value instanceof String) {
				String str = (String) value;
				CellCalculator cellCalculator = ((CassavaGrid) table)
						.getTableModel().getCellCalculator();
				if (cellCalculator != null) {
					str = cellCalculator.calc(str, row, column);
				}
				value = "<html>" + sanitize(str).replace("\n", "<br />")
						+ "</html>";
			}
		} catch (Exception ex) {
			// Use Original value
		}
		Component component = super.getTableCellRendererComponent(table, value,
				isSelected, hasFocus, row, column);
		if (component instanceof JLabel) {
			((JLabel) component).setVerticalAlignment(JLabel.TOP);
		}
		return component;
	}
}
