package net.asukaze.cassava.ui.util;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.net.URL;

public class BrowserUtil {
	public static final String IE_PATH = "C:\\Program Files\\Internet Explorer\\iexplore.exe"; //$NON-NLS-1$

	public static final String SERVICE_MANAGER = "javax.jnlp.ServiceManager"; //$NON-NLS-1$
	public static final String LOOKUP = "lookup"; //$NON-NLS-1$
	public static final String BASIC_SERVICE = "javax.jnlp.BasicService"; //$NON-NLS-1$
	public static final String SHOW_DOCUMENT = "showDocument"; //$NON-NLS-1$

	public static boolean showDocument(URL url) throws Exception {
		boolean nojnlp = false;
		try {
			Class<?> serviceManager = Class.forName(SERVICE_MANAGER);
			Method lookup = serviceManager.getMethod(LOOKUP, String.class);
			Object basicService = lookup.invoke(null, BASIC_SERVICE);
			Method showDocument = basicService.getClass().getMethod(
					SHOW_DOCUMENT, URL.class);
			Object opened = showDocument.invoke(basicService, url);
			if (Boolean.TRUE.equals(opened)) {
				return true;
			}
		} catch (ClassNotFoundException exc) {
			nojnlp = true;
		} catch (NoSuchMethodException e) {
			nojnlp = true;
		} catch (IllegalAccessException e) {
			nojnlp = true;
		} catch (InvocationTargetException e) {
			nojnlp = true;
		}
		if (nojnlp) {
			ProcessBuilder pb = new ProcessBuilder(IE_PATH, url
					.toExternalForm());
			pb.start();
		}
		return false;
	}
}
