package net.asukaze.cassava.ui.table;

import static org.junit.Assert.*;

import net.asukaze.cassava.ui.MainFrame;

import org.junit.Before;
import org.junit.Test;

public class CassavaGridTest {
	private MainFrame frame;

	@Before
	public void setUp() {
		frame = new MainFrame();
		frame.setVisible(true);
	}

	private int getStringHeights(String value) {
		return (int) frame.getCassavaGrid().getStringBounds(value).getHeight();
	}

	@Test
	public void testGetStringBounds() throws Exception {
		Thread.sleep(1000);
		int r1 = getStringHeights("one");
		int r2 = getStringHeights("one\ntwo");
		int r3 = getStringHeights("one\ntwo\nthree");
		int r4 = getStringHeights("one\ntwo\nthree\nfour");
		int r5_1 = getStringHeights("one\ntwo\nthree\nfour\n");
		int r5_2 = getStringHeights("one\n\n\nfour\n");
		int r6 = getStringHeights("\n\n\n\n\n");
		assertEquals(r1 * 2, r2);
		assertEquals(r1 * 3, r3);
		assertEquals(r1 * 4, r4);
		assertEquals(r1 * 5, r5_1);
		assertEquals(r1 * 5, r5_2);
		assertEquals(r1 * 6, r6);
	}
}
