package net.asukaze.cassava.macro;

@SuppressWarnings("serial")
public class FunctionNotFoundException extends MacroException {
	private static final String ARGS_SEPARATOR = "/"; //$NON-NLS-1$

	public FunctionNotFoundException(String name, int argCount) {
		super(Messages.getString(Messages.FUNCTION_NOT_FOUND) + name
				+ ARGS_SEPARATOR + argCount);
	}

	public FunctionNotFoundException(FunctionCall call) {
		super(Messages.getString(Messages.FUNCTION_NOT_FOUND) + call.getName()
				+ ARGS_SEPARATOR + call.getArgs().length);
	}
}
