package net.asukaze.cassava.macro.action;

import java.io.IOException;
import java.io.StringReader;

import javax.swing.JCheckBoxMenuItem;
import javax.swing.JMenuItem;

import net.asukaze.cassava.core.command.Command;
import net.asukaze.cassava.core.model.CellCalculator;
import net.asukaze.cassava.core.model.ICassavaTableModel;
import net.asukaze.cassava.macro.Macro;
import net.asukaze.cassava.macro.parser.ParseException;
import net.asukaze.cassava.ui.IApplication;
import net.asukaze.cassava.ui.action.Action;
import net.asukaze.cassava.ui.table.CassavaGrid;

public class CalcExpressionAction extends Action implements CellCalculator {
	public static final String CELL_CALC_PREFIX = "="; //$NON-NLS-1$

	private JCheckBoxMenuItem menuItem;

	@Override
	public JMenuItem createMenuItem() {
		this.menuItem = new JCheckBoxMenuItem();
		return menuItem;
	}

	private static Macro setupMacro(IApplication frame) {
		Macro macro = new Macro();
		CassavaGrid grid = frame.getCassavaGrid();
		macro.setModel(grid.getTableModel());
		macro.setViewModel(grid.getViewModel());
		return macro;
	}

	@Override
	public Command run() throws Exception {
		ICassavaTableModel model = getCassavaGrid().getTableModel();
		boolean menuCheck;
		if (model.getCellCalculator() == null) {
			model.setCellCalculator(this);
			menuCheck = true;
		} else {
			model.setCellCalculator(null);
			menuCheck = false;
		}
		if (menuItem != null) {
			menuItem.setSelected(menuCheck);
		}
		return null;
	}

	public String calc(String str, int rowIndex, int columnIndex)
			throws ParseException, IOException {
		if (str.startsWith(CELL_CALC_PREFIX)) {
			String script = str.substring(1);
			StringReader reader = new StringReader(script);
			Macro macro = setupMacro(getApplication());
			macro.getEnvironment().putVar("x", columnIndex + 1); //$NON-NLS-1$
			macro.getEnvironment().putVar("y", rowIndex + 1); //$NON-NLS-1$
			return macro.toString(macro.runExpr(reader));
		}
		return str;
	}
}
