package net.asukaze.cassava.macro.api;

import java.io.IOException;
import java.io.PrintStream;

import net.asukaze.cassava.macro.APIFunctionHandler;
import net.asukaze.cassava.macro.FunctionNotFoundException;
import net.asukaze.cassava.macro.Macro;

public class ConsoleWriteFunctionHandler implements APIFunctionHandler {
	private PrintStream printStream;

	public ConsoleWriteFunctionHandler(PrintStream printStream) {
		this.printStream = printStream;
	}

	public Object runAPIFunction(String name, Object[] args, Macro macro)
			throws IOException {
		int n = args.length;
		if ("write".equals(name)) { //$NON-NLS-1$
			write(args, macro);
			return null;
		} else if ("writeln".equals(name)) { //$NON-NLS-1$
			writeln(args, macro);
			return null;
		}
		return new FunctionNotFoundException(name, n);
	}

	private void write(Object[] args, Macro macro) throws IOException {
		for (int i = 0; i < args.length; i++) {
			String text = macro.toString(args[i]);
			printStream.print(text);
		}
	}

	private void writeln(Object[] args, Macro macro) throws IOException {
		write(args, macro);
		printStream.println();
	}

	public void close() {
	}
}
